﻿Namespace Library

    Public Class BookCategorty

        Public Enum SearchField
            نمایش_همه = 0
            'کد_کتاب = 1
            'نام_کتاب = 2
        End Enum

        Public Enum SortField
            بدون_مرتب_سازی = 0
            'کد_کتاب = 1
            'نام_کتاب = 2
        End Enum

        Public Function INSERT(ByVal BookCategorty_ID_Parent_ As Int64, _
                               ByVal CategoryName_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_BookCategorty_INSERT"
                cmd.Parameters.AddWithValue("@BookCategorty_ID_Parent", BookCategorty_ID_Parent_)
                cmd.Parameters.AddWithValue("@CategoryName", CategoryName_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function UPDATE(ByVal BookCategorty_ID_ As Int64, _
                               ByVal CategoryName_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_BookCategorty_UPDATE"
                cmd.Parameters.AddWithValue("@BookCategorty_ID", BookCategorty_ID_)
                cmd.Parameters.AddWithValue("@CategoryName", CategoryName_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function DELETE(ByVal BookCategorty_ID_ As Int64) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_BookCategorty_DELETE"
                cmd.Parameters.AddWithValue("@BookCategorty_ID", BookCategorty_ID_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function SELECT_ByID(ByVal BookCategorty_ID_ As Int64) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_BookCategorty_SELECT_ByID"
                cmd.Parameters.AddWithValue("@BookCategorty_ID", BookCategorty_ID_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

        Public Function IsExist_CategoryName(ByVal CategoryName_ As String, _
                                             ByVal BookCategorty_ID_Parent_ As Int64, _
                                             ByVal BookCategorty_ID_ As Int64) As Boolean

            Dim IsExist As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_BookCategorty_SELECT_COUNT_ByCategoryName"
                cmd.Parameters.AddWithValue("@CategoryName", CategoryName_)
                cmd.Parameters.AddWithValue("@BookCategorty_ID_Parent", BookCategorty_ID_Parent_)
                cmd.Parameters.AddWithValue("@BookCategorty_ID", BookCategorty_ID_)

                Dim countExist As Integer = CInt(cmd.ExecuteScalar())
                If countExist > 0 Then
                    IsExist = True
                End If

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsExist
        End Function

        Public Function SELECT_ALL(ByVal BookCategorty_ID_Parent_ As Int64) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.Text

                Dim query As String = ""
                query &= "Select BC.BookCategorty_ID" & vbCrLf
                query &= ",BC.BookCategorty_ID_Parent" & vbCrLf
                query &= ",BC.CategoryName" & vbCrLf
                query &= "FROM BookCategorty AS BC" & vbCrLf
                query &= "WHERE (1=1)" & vbCrLf
                If BookCategorty_ID_Parent_ = -1 Then
                    query &= "AND (BookCategorty_ID_Parent IS NULL) " & vbCrLf
                Else
                    query &= "AND (BookCategorty_ID_Parent = @BookCategorty_ID_Parent) " & vbCrLf
                End If
                query &= "ORDER BY BookCategorty_ID" & vbCrLf

                cmd.CommandText = query
                cmd.Parameters.AddWithValue("@BookCategorty_ID_Parent", BookCategorty_ID_Parent_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

    End Class

End Namespace






