﻿Namespace Library

    Public Class Books

        Public Enum SearchField
            نمایش_همه = 0
            کد_کتاب = 1
            نام_کتاب = 2
        End Enum

        Public Enum SortField
            بدون_مرتب_سازی = 0
            کد_کتاب = 1
            نام_کتاب = 2
        End Enum

        Public Function INSERT(ByVal BookCode_ As Int64, _
                               ByVal Title_ As String, _
                               ByVal Publisher_ As String, _
                               ByVal PublishYear_ As String, _
                               ByVal RowDesc_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Books_INSERT"
                cmd.Parameters.AddWithValue("@BookCode", BookCode_)
                cmd.Parameters.AddWithValue("@Title", Title_)
                cmd.Parameters.AddWithValue("@Publisher", Publisher_)
                cmd.Parameters.AddWithValue("@PublishYear", PublishYear_)
                cmd.Parameters.AddWithValue("@RowDesc", RowDesc_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function UPDATE(ByVal Book_ID_ As Int64, _
                               ByVal BookCode_ As Int64, _
                               ByVal Title_ As String, _
                               ByVal Publisher_ As String, _
                               ByVal PublishYear_ As String, _
                               ByVal RowDesc_ As String) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Books_UPDATE"
                cmd.Parameters.AddWithValue("@Book_ID", Book_ID_)
                cmd.Parameters.AddWithValue("@BookCode", BookCode_)
                cmd.Parameters.AddWithValue("@Title", Title_)
                cmd.Parameters.AddWithValue("@Publisher", Publisher_)
                cmd.Parameters.AddWithValue("@PublishYear", PublishYear_)
                cmd.Parameters.AddWithValue("@RowDesc", RowDesc_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function DELETE(ByVal Book_ID_ As Int64) As Boolean

            Dim IsComplete As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Books_DELETE"
                cmd.Parameters.AddWithValue("@Book_ID", Book_ID_)
                cmd.ExecuteNonQuery()

                IsComplete = True
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsComplete
        End Function

        Public Function SELECT_ByID(ByVal Book_ID_ As Int64) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Books_SELECT_ByID"
                cmd.Parameters.AddWithValue("@Book_ID", Book_ID_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

        Public Function IsExist_BookCode(ByVal BookCode_ As Int64, _
                                         ByVal Book_ID_ As Int64) As Boolean

            Dim IsExist As Boolean = False
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.StoredProcedure
                cmd.CommandText = "SP_Books_SELECT_COUNT_ByBookCode"
                cmd.Parameters.AddWithValue("@BookCode", BookCode_)
                cmd.Parameters.AddWithValue("@Book_ID", Book_ID_)

                Dim countExist As Integer = CInt(cmd.ExecuteScalar())
                If countExist > 0 Then
                    IsExist = True
                End If

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return IsExist
        End Function

        Public Function SELECT_ALL(ByVal SearchField_ As SearchField, _
                                   ByVal SearchValue_ As String, _
                                   ByVal SortField_ As SortField, _
                                   ByVal ASC_OR_DESC_ As Integer) As DataTable

            Dim dt As New DataTable
            Dim cn As New System.Data.SqlClient.SqlConnection(Library_Shared.PublicVariables.CnString)
            Try
                Dim cmd As New System.Data.SqlClient.SqlCommand
                cn.Open()
                cmd.Connection = cn
                cmd.CommandType = CommandType.Text

                Dim query As String = ""
                query &= "Select B.Book_ID" & vbCrLf
                query &= ",B.BookCode" & vbCrLf
                query &= ",B.Title" & vbCrLf
                query &= ",B.Publisher" & vbCrLf
                query &= ",B.PublishYear" & vbCrLf
                query &= ",B.RowDesc" & vbCrLf
                query &= "FROM Books AS B" & vbCrLf
                query &= "WHERE (1=1)" & vbCrLf
                Select Case SearchField_
                    Case SearchField.نمایش_همه
                        '...
                    Case SearchField.کد_کتاب
                        query &= "AND (B.BookCode = @SearchValue) " & vbCrLf
                    Case SearchField.نام_کتاب
                        query &= "AND (B.Title LIKE N'%' + @SearchValue + '%') " & vbCrLf
                End Select
                Dim str_ASC_OR_DESC_ As String = ""
                If ASC_OR_DESC_ = 0 Then
                    str_ASC_OR_DESC_ = "ASC"
                Else
                    str_ASC_OR_DESC_ = "DESC"
                End If
                Select Case SortField_
                    Case SortField.بدون_مرتب_سازی
                        '...
                    Case SortField.کد_کتاب
                        query &= "ORDER BY BookCode " & str_ASC_OR_DESC_ & vbCrLf
                    Case SortField.نام_کتاب
                        query &= "ORDER BY Title " & str_ASC_OR_DESC_ & vbCrLf
                End Select
                query &= "" & vbCrLf

                cmd.CommandText = query
                cmd.Parameters.AddWithValue("@SearchValue", SearchValue_)

                Dim da As New System.Data.SqlClient.SqlDataAdapter
                da.SelectCommand = cmd
                da.Fill(dt)

            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "خطا")
            End Try
            '-----------------
            If cn.State = ConnectionState.Open Then
                cn.Close()
            End If
            Return dt
        End Function

    End Class

End Namespace






