﻿Public Class FrmSelectLendingBooks

#Region "Variables"
    Private txtSearch_DefaultSize As New System.Drawing.Size(268, 21)
    Private txtSearch_MinizedSize As New System.Drawing.Size(131, 21)
#End Region

#Region "Controls And Forms Events"

    Private Sub btnSearch_Click(sender As Object, e As EventArgs) Handles btnSearch.Click
        FillGrid()
    End Sub

    Private Sub FrmSelectMembers_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cboSearch.SelectedIndex = 0
        cboSortField.SelectedIndex = 0
        cboSortType.SelectedIndex = 0
    End Sub

    Private Sub btnAdd_Click(sender As Object, e As EventArgs) Handles btnAdd.Click
        Dim Frm_ As New FrmNewLendingBooks
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_افزودن
        Frm_.Show()
        Frm_.Focus()
    End Sub

    Private Sub btnEdit_Click(sender As Object, e As EventArgs) Handles btnEdit.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی جهت ویرایش انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewLendingBooks
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_ویرایش
        Frm_.LendingBook_ID_ = CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value)
        Frm_.Show()
        Frm_.Focus()
    End Sub

    Private Sub btnView_Click(sender As Object, e As EventArgs) Handles btnView.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی جهت ویرایش انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        Dim Frm_ As New FrmNewLendingBooks
        Frm_.CalledForm_ = Me
        Frm_.FormMode_ = Library_Shared.Enums.FormMode.حالت_نمایش
        Frm_.LendingBook_ID_ = CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value)
        Frm_.Show()
        Frm_.Focus()
    End Sub

    Private Sub btnDelete_Click(sender As Object, e As EventArgs) Handles btnDelete.Click
        If DataGridView1.Rows.Count = 0 Then
            MsgBox("رکوردی جهت حذف انتخاب نشده است", MsgBoxStyle.Critical, "خطا")
            Exit Sub
        End If
        If MsgBox("آیا از حذف رکورد انتخاب شده مطمئن هستید", MsgBoxStyle.Question + MsgBoxStyle.YesNo, "تایید حذف") = MsgBoxResult.No Then Exit Sub

        Dim obj_Members As New Library_Database.Library.LendingBooks
        Dim IsComplete As Boolean = obj_Members.DELETE(CLng(DataGridView1.CurrentRow.Cells.Item("RowID").Value))

        If IsComplete = True Then
            MsgBox("رکورد با موفقیت حذف شد", MsgBoxStyle.Information, "پیغام")
            Me.FillGrid()
        End If
    End Sub

    Private Sub cboSearch_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboSearch.SelectedIndexChanged
        txtSearch.Location = Me.txtSearch2.Location
        txtSearch2.Visible = False
        txtSearch.Size = Me.txtSearch_DefaultSize
        Select Case cboSearch.SelectedIndex
            Case Library_Database.Library.LendingBooks.SearchField.نمایش_همه

            Case Library_Database.Library.LendingBooks.SearchField.کد_عضویت

            Case Library_Database.Library.LendingBooks.SearchField.نام_عضو

            Case Library_Database.Library.LendingBooks.SearchField.نام_خانوادگی

            Case Library_Database.Library.LendingBooks.SearchField.کد_کتاب

            Case Library_Database.Library.LendingBooks.SearchField.نام_کتاب

            Case Library_Database.Library.LendingBooks.SearchField.تاریخ_امانت_دادن_کتاب
                txtSearch2.Visible = True
                txtSearch.Size = Me.txtSearch_MinizedSize
                txtSearch.Location = New System.Drawing.Point(Me.txtSearch2.Right + 6, Me.txtSearch2.Location.Y)
            Case Library_Database.Library.LendingBooks.SearchField.موعد_برگرداندن_کتاب
                txtSearch2.Visible = True
                txtSearch.Size = Me.txtSearch_MinizedSize
                txtSearch.Location = New System.Drawing.Point(Me.txtSearch2.Right + 6, Me.txtSearch2.Location.Y)
        End Select
    End Sub

#End Region

#Region "My Rutins"

    Public Sub FillGrid()
        Dim obj_Members As New Library_Database.Library.LendingBooks
        Dim dt As DataTable = obj_Members.SELECT_ALL(cboSearch.SelectedIndex, txtSearch.Text.Trim, txtSearch2.Text.Trim, cboSortField.SelectedIndex, cboSortType.SelectedIndex)
        DataGridView1.DataSource = dt
    End Sub

#End Region







End Class